#!/usr/bin/env python

from decorator import *

def getattr_(obj, name, default_thunk):
    "Similar to .setdefault in dictionaries."
    try:
        return getattr(obj, name)
    except AttributeError:
        default = default_thunk()
        setattr(obj, name, default)
        return default

@decorator
def memoize(func, *args):
    dic = getattr_(func, "memoize_dic", dict)
    # memoize_dic is created at the first call
    if args in dic:
        return dic[args]
    else:
        result = func(*args)
        dic[args] = result
        return result

@memoize
def fib(n):
    print "%d is caculated" % n
    if  n < 2 :
    	return 1;
    else:
	return fib(n-1) + fib(n-2)

if __name__ == "__main__":
    print fib(10)